// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../sinon

import { SinonStub } from 'sinon';

export class ImportMock {
    static mockClass<T, K extends IModule = any>(module: {
        [importName: string]: IConstruct<T>;
    } | K, importName?: keyof K): MockManager<T>;
    static mockStaticClass<T, K extends IModule = any>(module: {
        [importName: string]: IConstruct<T>;
    } | K, importName?: keyof K): StaticMockManager<T>;
    static mockFunction<K extends IModule>(module: {
        [importName: string]: () => any;
    } | K, importName?: keyof K, returns?: any): sinon.SinonStub;
    static mockOther<T extends IModule, K extends keyof T>(module: {
        [importName: string]: T[K];
    } | T, importName?: K, replaceWith?: T[K]): OtherManager<T[K]>;
}

export class Manager {
    protected module: IModule;
    protected importName: string;
    protected original: any;
    constructor(module: IModule, importName: string);
    restore(): void;
}

export interface IMockOptions {
    returns?: any;
}
export class MockManager<T> extends Manager {
    protected module: IModule;
    protected importName: string;
    protected original: IConstruct<T>;
    protected stubClass: IConstruct<T>;
    constructor(module: IModule, importName: string);
    mock(funcName: StringKeyOf<T>, returns?: any): sinon.SinonStub;
    set<K extends keyof T & string>(varName: K, replaceWith?: T[K]): void;
    getMockInstance(): T;
    protected mockFunction(funcName: string, returns?: any): sinon.SinonStub;
    protected replaceFunction(funcName: string, newFunc: () => any): void;
    protected replace(name: string, arg: any): void;
    protected getAllFunctionNames(obj: any): string[];
    protected createStubClass(): void;
}

export class OtherManager<T> extends Manager {
    protected module: IModule;
    protected importName: string;
    protected original: T;
    constructor(module: IModule, importName: string, replaceWith?: any);
    set(replaceWith: T): void;
    getValue(): T;
}

export class StaticMockManager<T> extends MockManager<T> {
    mock(funcName: StringKeyOf<IConstruct<T>>, ...args: any[]): SinonStub;
    set(varName: string, replaceWith: any): void;
    protected replace(name: string, arg: any): void;
    protected getAllFunctionNames(obj: any): string[];
}

export interface IConstruct<T> {
    new (...args: any[]): T;
    [key: string]: any;
}

export interface IModule {
    [importName: string]: any;
}

export type StringKeyOf<T> = keyof T & string;

